/**
 * CMI : Cluster Method Invocation
 * Copyright (C) 2007,2008 Bull S.A.S.
 * Contact: cmi@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * --------------------------------------------------------------------------
 * $Id: CMIProxy.java 2438 2010-02-24 16:20:30Z benoitf $
 * --------------------------------------------------------------------------
 */

package org.ow2.cmi.rpc;

import org.ow2.cmi.reference.CMIReferenceable;

/**
 * The CMI proxy intercepts the remote method invocations.
 * It is the common interface of proxies that have as handler the class {@link org.ow2.cmi.rpc.POJOInvocationHandler}.
 * @author The new CMI team
 * @see org.ow2.cmi.rpc.POJOInvocationHandler
 */
public interface CMIProxy {

    /**
     * @return the name of the handled object
     */
    String getObjectName_CMI();

    /**
     * @return the interface implemented by the handled object
     */
    Class<?> getInterface_CMI();

    /**
     * @return the name of the used protocol
     */
    String getProtocolName_CMI();

    /**
     * @return an handle
     */
    Object getHandle_CMI();

    /**
     * @return true if the previous object must be reused
     */
    boolean isCMIRefKept_CMI();

    /**
     * @return the object to use for the invocation
     */
    CMIReferenceable<?> getCurrentCMIRef_CMI();

}
